//----------------------------------------------------------------------//
// NyanFi																//
//  GREPgݒ														//
//----------------------------------------------------------------------//
#include "usr_shell.h"
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "MainFrm.h"
#include "GrepOptDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGrepExOptDlg *GrepExOptDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TGrepExOptDlg::TGrepExOptDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::FormCreate(TObject *Sender)
{
	UserModule->SetUsrPopupMenu(this);

	//Rg[̃^OɁAΉϐ̃|C^ݒ
	OutFileEdit->Tag		= (NativeInt)&GrepFileName;
	AppNameEdit->Tag		= (NativeInt)&GrepAppName;
	AppParamEdit->Tag		= (NativeInt)&GrepAppParam;
	AppDirEdit->Tag 		= (NativeInt)&GrepAppDir;
	FileFmtEdit->Tag		= (NativeInt)&GrepFileFmt;
	InsStrWEdit->Tag		= (NativeInt)&GrepInsStrW;
	InsStrW2Edit->Tag		= (NativeInt)&GrepInsStrW2;
	RepCrEdit->Tag			= (NativeInt)&GrepRepCrStr;
	FExtBakEdit->Tag		= (NativeInt)&FExtRepBackup;
	RepBakDirEdit->Tag		= (NativeInt)&RepBackupDir;
	LogFileEdit->Tag		= (NativeInt)&ReplaceLogName;
	AppEnabledCheckBox->Tag = (NativeInt)&GrepAppEnabled;
	AppendCheckBox->Tag 	= (NativeInt)&GrepAppend;
	TrimLeftCheckBox->Tag	= (NativeInt)&GrepTrimLeft;
	RepTabCheckBox->Tag 	= (NativeInt)&GrepReplaceTab;
	RepCrCheckBox->Tag		= (NativeInt)&GrepReplaceCr;
	BakRepCheckBox->Tag 	= (NativeInt)&BackupReplace;
	SaveLogCheckBox->Tag	= (NativeInt)&SaveReplaceLog;
	AppendLogCheckBox->Tag	= (NativeInt)&ReplaceAppend;
	OpenLogCheckBox->Tag	= (NativeInt)&OpenReplaceLog;

	//hbv^[Qbgݒ
	usr_SH->AddTargetList(this, AppNameEdit);
}
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::FormShow(TObject *Sender)
{
	SetDarkWinTheme(this);
	SampleMemo->Color		= get_WinColor();
	SampleMemo->Font->Color = get_TextColor();

	//^OpăRg[ɒlݒ
	BringOptionByTag(this);

	switch (GrepOutMode) {
	case  1: OutMode1Btn->Checked = true; break;
	case  2: OutMode2Btn->Checked = true; break;
	default: OutMode0Btn->Checked = true;
	}

	//
	if (NyanFiForm->GrepPageControl->ActivePage==NyanFiForm->FindSheet) {
		OutModeSheet->TabVisible = true;
		OutFormSheet->TabVisible = true;
		ReplaceSheet->TabVisible = false;
		InsStrWEdit->Enabled	 = true;
		InsStrW2Edit->Enabled	 = true;
	}
	//u
	else {
		OutModeSheet->TabVisible = false;
		OutFormSheet->TabVisible = true;
		ReplaceSheet->TabVisible = true;
		InsStrWEdit->Enabled	 = false;
		InsStrW2Edit->Enabled	 = false;
	}
	SampleChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	GrepOutMode = OutMode1Btn->Checked? 1 : OutMode2Btn->Checked? 2: 0;
}

//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::PageControl1DrawTab(TCustomTabControl *Control,
	int TabIndex, const TRect &Rect, bool Active)
{
	draw_OwnerTab(Control, TabIndex, Rect, Active, IsDarkMode);
}

//---------------------------------------------------------------------------
//bv󂯓
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::WmDropped(TMessage &msg)
{
	SetExtNameToCtrl(DroppedList->Strings[0], (TWinControl *)msg.WParam);
}

//---------------------------------------------------------------------------
//o̓t@C̎Q
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::RefOutBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("o̓t@C̎w"), F_FILTER_TXT);
	UserModule->OpenDlgToEdit(OutFileEdit);
	SetFocus();
}

//---------------------------------------------------------------------------
//NAv̎Q
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::RefAppBtnClick(TObject *Sender)
{
	UnicodeString fnam = AppNameEdit->Text;
	UserModule->PrepareOpenDlg(_T("NAvP[V̎w"), F_FILTER_EXE, fnam.c_str(), ExtractFilePath(fnam));
	UserModule->OpenDlgToEdit(AppNameEdit);
	SetFocus();
}
//---------------------------------------------------------------------------
//ƃfBNg̎Q
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::RefDirBtnClick(TObject *Sender)
{
	UnicodeString dnam = GrepAppDir;
	if (UserModule->SelectDirEx(_T("ƃfBNg"), dnam)) AppDirEdit->Text = dnam;
}

//---------------------------------------------------------------------------
//Tv\̍XV
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::SampleChange(TObject *Sender)
{
	SampleMemo->Lines->Clear();

	UnicodeString f_inf = FileFmtEdit->Text;
	if (f_inf.IsEmpty()) f_inf = "$F $L:";

	f_inf = ReplaceStr(f_inf, "$F", "D:\\hoge.txt");
	f_inf = ReplaceStr(f_inf, "$L", "123");
	f_inf = conv_esc_char(f_inf);

	std::unique_ptr<TStringList> l_list(new TStringList());
	UnicodeString ln_str;
	if (NyanFiForm->GrepPageControl->ActivePage==NyanFiForm->FindSheet) {
		ln_str = "͌";
		ln_str += conv_esc_char(InsStrWEdit->Text);
		ln_str += "}b`";
		ln_str += conv_esc_char(InsStrW2Edit->Text);
		ln_str += "łB";
	}
	else {
		ln_str = "͒uʂ̃TvłB";
	}

	ln_str += "\n2sڂłBsɃ^u͂܂B\n\t3sڂłBsɃ^u܂B";

	if (RepTabCheckBox->Checked) ln_str = ReplaceStr(ln_str, "\t", " ");
	if (TrimLeftCheckBox->Checked) {
		TStringDynArray l_lst = SplitString(ln_str, "\n");
		ln_str = EmptyStr;
		for (int j=0; j<l_lst.Length; j++) {
			if (!ln_str.IsEmpty()) ln_str += "\n";
			ln_str += TrimLeft(l_lst[j]);
		}
	}

	if (RepCrCheckBox->Checked)
		ln_str = ReplaceStr(ln_str, "\n", conv_esc_char(RepCrEdit->Text));
	else
		ln_str = ReplaceStr(ln_str, "\n", "\r\n");

	SampleMemo->Text = f_inf + ln_str;
}


//---------------------------------------------------------------------------
//obNAbv̎Q
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::RefBakBtnClick(TObject *Sender)
{
	UnicodeString dnam = GrepAppDir;
	if (UserModule->SelectDirEx(_T("obNAbv"), dnam)) RepBakDirEdit->Text = dnam;
}

//---------------------------------------------------------------------------
//Ot@C̎Q
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::RefLogBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("uOt@C̎w"), F_FILTER_TXT);
	UserModule->OpenDlgToEdit(LogFileEdit);
	SetFocus();
}
//---------------------------------------------------------------------------
//m
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::OkButtonClick(TObject *Sender)
{
	//Rg[̃^OɂĕύXKp
	ApplyOptionByTag((TForm *)this);
}

//---------------------------------------------------------------------------
//wv
//---------------------------------------------------------------------------
bool __fastcall TGrepExOptDlg::FormHelp(WORD Command, NativeInt Data, bool &CallHelp)
{
	if (Command==HELP_CONTEXT || Command==HELP_CONTEXTPOPUP) {
		UnicodeString topic = (NyanFiForm->GrepPageControl->ActivePage==NyanFiForm->FindSheet)? HELPTOPIC_GR : HELPTOPIC_RP;
		topic += "#Option";
		HtmlHelpTopic(topic.c_str());
		CallHelp = false;
	}

	return true;
}
//---------------------------------------------------------------------------

